;
; Np
;

	relaxed on

Disk_Init	equ	$00c0
Disk_Change1DD	equ	$00cc
RAMCHECK	equ	$ba03
RAM_MSG		equ	$ba06


	org	$f900

;
; Track#0 Sector#1`
;
	db	"SYS"		; +0
	jr	START		; +3

;
; ZN^ǂݍ݁iROM[`gpj
;
READ_NSEC:
.loop:
	push	af
	ld	a,$01
	or	a
	push	bc
	push	de		; i[AhX
	call	$4274		; ZN^ǂݍ
	pop	de
	pop	bc
	inc	d
	inc	c		; ZN^ԍ
	ld	a,c
	cp	$11
	jr	c,.lp1
	ld	c,$01
	inc	b		; gbNԍ
.lp1:	pop	af
	dec	a
	jr	nz,.loop
	ret

;
; ԑ҂i 2ms ~ HLj
;
W_TIME:
.lp1:	ld	a,$78
.lp2:	dec	a
	jr	nz,.lp2

	dec	hl
	ld	a,h
	or	l
	jr	nz,.lp1
	ret

START:
	ld	sp,$b600

	xor	a		; hCuԍ-1
	ld	(ix+0),a
	ld	(ix+27),a	; G[JEg

	ld	bc,$0002	; Breg:gbNԍACreg:ZN^ԍ
	ld	de,$b800	; i[AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC

	ld	c,$0d		; CregFZN^ԍihCupǂݏo[`j
	ld	a,($fe74)	; bit7`0 = Ot#2A#1A#2A#1A"0000"
	ld	(DRVINFO),a
	bit	4,a
	jr	nz,.fdboot_in
	ld	c,$0f		; CregFZN^ԍiOthCupǂݏo[`j
;
; u[gpfBXN[`ǂݍ
;
.fdboot_in:
	ld	b,$00		; BregFgbNԍ
	ld	de,$b600	; i[擪AhX
	ld	a,$02		; ǂݍރZN^
	call	READ_NSEC

	ld	a,(DRVINFO)
	bit	4,a
	jr	z,.fdboot_out
	ld	a,$21
	ld	($b601),a	; 1D̎̏AhXɕύX
.fdboot_out:

;
; ʃNA
;
	ld	hl,$4000
.lp1:	ld	(hl),$0f
	inc	hl
	ld	a,h
	cp	$44
	jr	nz,.lp1
.lp2:	ld	(hl),$20
	inc	hl
	ld	a,h
	cp	$48
	jr	nz,.lp2

	ld	de,VER_MSG
	call	PNT_MSG

;
; Nʐݒ
;
	ld	a,$fd		; 160x200 / character / 40x20
	out	($c1),a
	ld	a,$f7
	out	($b0),a		; VRAMAhX=0x4000A^C}荞OFF

;
; u[gpfBXN[`̏
;
	ld	d,$00
	call	$b600		; Init
	jp	c,DISKNG

;	ld	d,$00
;	call	$b60c		; set 1DD
;	jp	c,DISKNG

;
; 1DDhCuǂmF
;
	ld	de,$0110	; DregFgbNԍAEregFZN^ԍ
	ld	hl,$ba00	; i[擪AhX
	ld	bc,$0100	; ǂݍރZN^^hCuԍ
	call	$b603

	ld	hl,$ba00
	ld	a,(hl)
	cp	'W'
	jp	nz,DISKNG
	inc	hl
	ld	a,(hl)
	cp	'I'
	jp	nz,DISKNG
	inc	hl
	ld	a,(hl)
	cp	'Z'
	jp	nz,DISKNG

;
; 荞ݏȂǂǂݍ
;
	ld	de,$000c	; DregFgbNԍAEregFZN^ԍ
	ld	hl,$8000	; i[擪AhX
	ld	bc,$0100	; ǂݍރZN^^hCuԍ
	call	$b603

	jp	MAIN

;
; RAMG[\
;
RAMNG:
	ld	de,RAMNG_MSG
	jp	DISKNG.disp

DRVINFO:
	db	$00	; hCu

RAMNG_MSG:
	db	$96,$98,$e1,$8e,$93,$20			; 傤
	db	"RAM",$96,$de,$20			; q`lJ
	db	$eb,$e2,$f6,$93,$e3,$de,$9d,$a1,$00	; Ђ悤āJB

VER_MSG:
	db	"Wiz1/2/3 for P6 ver1.4",$0d,$0d,$00

DISKNG_MSG:
	db	"Disk error",$00



	org	$fa00
	phase	$b800

MAIN:

;
; `FbNƐݒ
;
	di

	ld	a,$ee
	out	($f0),a		; 0x0000-0x7FFF̓ǂݏoORAM
	ld	a,$ed
	out	($f1),a		; 0xC000-0xFFFF̓ǂݏoORAM
	ld	a,$9a
	out	($f2),a		; 0x0000-0x7FFFA0xC000-0xFFFF݂̏ORAM

	call	RAMCHECK

	ld	a,$11
	out	($f0),a		; ǂݏoBASIC-ROMɂ
	ld	a,$dd
	out	($f1),a		; ǂݏoRAMɂ
	ld	a,$55
	out	($f2),a		; 0x0000-0xFFFF݂̏RAM
	ei

	ld	a,h
	or	a
	jp	z,RAMNG

	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K

	call	$1058		; L[obt@NA

	ld	hl,2000/2	; 1b҂
	call	W_TIME

	call	$1061		; Q[L[

	ld	b,1		; 16K
	bit	1,a
	jr	nz,.gked
	ld	b,4		; 64K
	bit	7,a
	jr	z,.nogk
.gked:
	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	ld	a,b
	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
.nogk:

	ld	de,RAM_MSG
	call	PNT_MSG

	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K

	ld	b,a
.rm2:
	rrc	b
	jr	c,.rm1
	inc	de
	inc	de
	inc	de
	inc	de
	inc	de
	inc	de
	jr	.rm2

.rm1:
	call	PNT_MSG

	ld	hl,2000/2	; 1b҂
	call	W_TIME

	call	$0fbc		; P
	jr	z,.next
	sub	'0'
	jr	c,.next
	cp	6
	jr	nc,.next

	ld	(MAIN.col1+1),a
	ld	a,$18		; jr $xxxx
	ld	(MAIN.col2),a
.next:

;
; CvOǂݍ
;
	ld	de,$020d	; Dreg:gbNԍAEreg:ZN^ԍ
	ld	hl,$8100	; i[AhX
	ld	bc,$3000	; ǂݍރZN^^hCuԍ
	call	$b603

;
; fBXNǂݏ[`ǂݍ
;
	ld	a,(DRVINFO)
	bit	4,a
	push	af
	ld	e,$04		; EregFZN^ԍihCupǂݏo[`j
	jr	nz,.fd_in
	ld	e,$08		; EregFZN^ԍiOthCupǂݏo[`j
.fd_in:
	ld	d,$00		; DregFgbNԍ
	ld	hl,$ba00	; i[擪AhX
	ld	bc,$0400	; ǂݍރZN^^hCuԍ
	call	$b603

	pop	af
	jr	z,.fd_out
	ld	a,$1a
	ld	($ba01),a	; 1D̎̏AhXɕύX
.fd_out:


;
; fBXN[`̃pb`𓖂Ă
;
	ld	hl,$ba00
	ld	de,$80c0
	ld	bc,$022a
	ldir

	ld	hl,$bd00
	ld	de,$98e9
	ld	bc,$0100
	ldir


;
; fBXNpbp[ǂݍ
; ipb`𓖂Ăj
;
	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	cp	$04
	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K

	ld	de,$0101	; Dreg:gbNԍAEreg:ZN^ԍidiskwrap.asmj16Kp
	ld	bc,$0200	; ǂݍރZN^^hCuԍ
	jr	c,.nc1
	ld	de,$0103	; Dreg:gbNԍAEreg:ZN^ԍidiskwrap_c.asmj64K/128Kp
	ld	bc,$0100	; ǂݍރZN^^hCuԍ
.nc1:
	ld	hl,$9b67	; i[AhX
	call	$b603

	xor	a
	ld	($9b73),a	; FLAG1D1Dɐݒ

;
; LbVvOǂݍ
;

	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	ld	hl,$b100	; i[AhX
	ld	bc,$0300	; ǂݍރZN^^hCuԍ
	jr	c,.nc2
	jr	nz,.c64

	ld	de,$0104	; Dreg:gbNԍAEreg:ZN^ԍidiskcache.asmj64Kp
	call	$b603
	jr	.nc2

.c64:
	ld	de,$0107	; Dreg:gbNԍAEreg:ZN^ԍidiskcache128.asmj128Kp
	call	$b603

	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	push	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K

	ld	hl,$00d9	; 128KLbVTCY
	cp	$10
	jr	c,.csz
	ld	hl,$0200	; 256KLbVTCY
	cp	$20
	jr	c,.csz
	ld	hl,$0400	; 512KLbVTCY
.csz:
	ld	($b10d),hl	; LbVTCY

.nc2:

	xor	a
	ld	($b10c),a	; FLAG1D1Dɐݒ


	di

	ld	a,$ff		; oXNGXgOFF
	out	($c8),a		; iSR̂݁Amk2ɂ̓|[gȂj

	pop	af		; AregF0x01=16K/0x02=32K/0x04=64K/0x08=128K/0x10=256K/0x20=512K
	jr	c,.nc3

	ld	a,$40+13
	out	($35),a		; 0xA000-0xBFFF̊ORAM#13ɐݒiVx[KJ[gbWj
	inc	a
	out	($36),a		; 0xC000-0xDFFF̊ORAM#14ɐݒiVx[KJ[gbWj
	inc	a
	out	($37),a		; 0xE000-0xFFFF̊ORAM#15ɐݒiVx[KJ[gbWj

	ld	a,$65
	out	($f2),a		; 0x8000-0xBFFF݂̏ORAMɂ

	ld	de,$bd00
	ld	hl,$b100
	ld	bc,$0300
	ldir

.nc3:
	ld	a,$dd
	out	($f0),a		; 0x0000-0x7FFF̓ǂݏoRAM
	out	($f1),a		; 0x8000-0xFFFF̓ǂݏoRAM
	ld	a,$55
	out	($f2),a		; 0x0000-0xFFFF݂̏RAM

;
; VRAMNAiOtBbNj
;
	ld	hl,$c000
.lp1:	ld	(hl),$00
	inc	hl
	ld	a,h
	or	a
	jr	nz,.lp1


	ld	a,$ed
	out	($f1),a		; 0xC000-0xFFFF̓ǂݏoORAMɂ
	ld	a,$95
	out	($f2),a		; 0xC000-0xFFFF݂̏ORAMɂ

;
; OɓǂݏoAC[`]
;
	ld	hl,$8000
	ld	de,$0000
	ld	bc,$3100
	ldir

;
; fBXN[`̏
;
	ld	d,$00
	call	Disk_Init
	jp	c,DISKNG

;	ld	d,$00
;	call	Disk_Change1DD
;	jr	c,DISKNG

;
; ݒ
;
	im	2
	ld	a,$00
	ld	i,a		; 荞݃e[u0x0000`ɐݒ

	ld	a,$02
	out	($93),a		; ʂ

	ld	a,$f1		; 320x200 / graphic / 40x20
	out	($c1),a

	ld	a,$f3
	out	($b0),a		; VRAMAhX=0xC000A^C}荞OFF

.col1:	ld	a,$00
	and	$07
	or	$f8
	out	($c0),a		; css1-3 = 000

		;
		; SRǂ|[g0xA3gĔ
		;
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	d,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	e,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	ld	b,a
	in	a,($a3)
	cpl			; ]i|[gȂȂ0x00)
	or	b
	or	d
	or	e
.col2:	jr	z,.nosr		; jr z,$xxxx / jr $xxxx

	ld	a,$03
	and	$07
	or	$f8
	out	($c0),a		; css1-3 = 000

				; pbg̐ݒ
	ld	a,$06		; 
	out	($40),a
	ld	a,$00		; 
	out	($41),a
	ld	a,$05		; 
	out	($42),a
	ld	a,$07		; 
	out	($43),a

.nosr:

	ld	a,$03
	out	($93),a		; ʂ\

	ld	a,$07
	out	($a0),a		; ~LT[
	ld	a,$bf
	out	($a1),a		; `l`o͂

	ld	a,$08
	out	($a0),a		; `l`
	xor	a
	out	($a1),a

	ld	sp,$0000

	ei

	call	$1b6d		; LbVL

	jp	$032c


;
; fBXNG[\
;
DISKNG:
	ld	de,DISKNG_MSG
.disp:	di
	ld	a,$dd
	out	($f1),a		; 0x8000-0xFFFF̓ǂݏoRAM
	ld	a,$55
	out	($f2),a		; 0x0000-0xFFFF݂̏RAM
	call	PNT_MSG
	jr	$

;
; \
;
PNT_MSG:
	push	bc
	ld	bc,(CUR_XY)
.lp1:
	ld	a,(de)
	inc	de
	or	a
	jr	z,.end
	cp	$0d
	jr	nz,.nom

	ld	c,0
	inc	b
	jr	.lp1
.nom:
	push	af
	push	bc

	ld	a,b
	add	a,a		; x2
	add	a,a		; x4
	add	a,b		; x5
	ld	l,a
	ld	h,0
	add	hl,hl		; x10
	add	hl,hl		; x20
	add	hl,hl		; x40
	ld	b,$44		; VRAMy[Wݒ
	add	hl,bc

	pop	bc
	pop	af
	ld	(hl),a
	inc	c

	ld	a,c
	cp	40
	jr	c,.lp1
	ld	c,0
	inc	b
	jr	.lp1

.end:
	ld	(CUR_XY),bc
	pop	bc
	ret

CUR_XY:	dw	$00


	dephase

	org	$fbff
	db	$ff


end

